(defun c:roof-new-new-new ( / *error* _offset unit rlw offd inside-p collinear-p unique chkcircinside preprocess1 preprocess2 subbody subprocess process done lw lwi lwx ent enti lil lix lwnl el p1 p2 pp ppp ipp ippl vll vlli tll iplst lst lstt ) ;;; cad, doc, spc, lay, vlll, vllli, tlll, f - global variables ;;;

  (vl-load-com)

  (defun *error* ( m )
    (if (and lwi (not (vlax-erased-p lwi)))
      (entdel lwi)
    )
    (if (and enti (not (vlax-erased-p enti)))
      (entdel enti)
    )
    (while (setq el (entnext el))
      (if (and el (not (vlax-erased-p el)))
        (entdel el)
      )
    )
    (if (setq ppp (unique ppp))
      (foreach pp ppp
        (if (not (vl-some '(lambda ( x ) (and (not (equal (car x) pp 1e-6)) (not (equal (cadr x) pp 1e-6)) (not (equal (car x) (cadr x) 1e-6)) (collinear-p (car x) pp (cadr x)))) lil))
          (entmake (list (cons 0 "POINT") (cons 10 pp) (cons 62 1)))
        )
      )
    )
    (if lil
      (foreach li lil
        (if (vl-some '(lambda ( x ) (and (not (equal (car li) x 1e-6)) (not (equal (cadr li) x 1e-6)) (not (equal (car li) (cadr li) 1e-6)) (collinear-p (car li) x (cadr li)))) ppp)
          (setq lil (vl-remove li lil))
          (if (vl-some '(lambda ( x ) (equal x (car li) 1e-6)) ppp)
            (entmake (list (cons 0 "LINE") (cons 10 (car li)) (cons 11 (cadr li)) (cons 62 3)))
          )
        )
      )
    )
    (command-s "_.-OVERKILL" "_ALL" "_T" "_Y" "" "")
    (if (= 8 (logand 8 (getvar 'undoctl)))
      (vla-endundomark doc)
    )
    (prompt "\nIf you want to start again on different sample, make sure you nil flag f : (setq f nil vlll nil vllli nil tlll nil) ...")
    (if m
      (prompt m)
    )
    (princ)
  )

  (defun _offset ( lw dist / lill lww vl lwx tl tln iplst lws )
    (setq vl (mapcar 'cdr (vl-remove-if '(lambda ( x ) (/= (car x) 10)) (setq lwx (entget lw)))))
    (setq tl (mapcar '(lambda ( a b ) (list a b)) vl (append (cdr vl) (list (car vl)))))
    (setq tln (mapcar '(lambda ( x ) (list (polar (car x) (+ (* 0.5 pi) (angle (car x) (cadr x))) (- dist)) (polar (cadr x) (+ (* 0.5 pi) (angle (car x) (cadr x))) (- dist)))) tl))
    (setq iplst (mapcar '(lambda ( a b ) (inters (car a) (cadr a) (car b) (cadr b) nil)) tln (append (cdr tln) (list (car tln)))))
    (setq lill (mapcar '(lambda ( a b ) (list a b)) iplst (append (cdr iplst) (list (car iplst)))))
    (setq lill (vl-remove-if '(lambda ( x ) (or (null (car x)) (null (cadr x)))) lill))
    (setq lws
      (cons
        (setq lww
          (entmakex
            (append
              (list
                (cons 0 "LWPOLYLINE")
                (cons 100 "AcDbEntity")
                (cons 100 "AcDbPolyline")
                (cons 90 (length iplst))
                (cons 70 (1+ (* 128 (getvar 'plinegen))))
                (cons 38 0.0)
              )
              (mapcar '(lambda ( p ) (cons 10 p)) iplst)
              (list (list 210 0.0 0.0 1.0))
            )
          )
        )
        lws
      )
    )
  )

  (defun unit ( v / d )
    (if (not (equal (setq d (distance '(0.0 0.0 0.0) v)) 0.0 1e-6))
      (mapcar '(lambda ( x ) (/ x d)) v)
    )
  )

  (defun rlw ( lw / e x1 x2 x3 x4 x5 x6 )
    ;; by ElpanovEvgeniy
    (if (= (cdr (assoc 0 (setq e (entget lw)))) "LWPOLYLINE")
      (progn
        (foreach a1 e
          (cond ((= (car a1) 10) (setq x2 (cons a1 x2)))
                ((= (car a1) 40) (setq x4 (cons (cons 41 (cdr a1)) x4)))
                ((= (car a1) 41) (setq x3 (cons (cons 40 (cdr a1)) x3)))
                ((= (car a1) 42) (setq x5 (cons (cons 42 (- (cdr a1))) x5)))
                ((= (car a1) 210) (setq x6 (cons a1 x6)))
                (t (setq x1 (cons a1 x1)))
          )
        )
        (entmod (append (reverse x1)
                  (append (apply 'append
                            (apply 'mapcar
                              (cons 'list
                                (list x2
                                  (cdr (reverse (cons (car x3) (reverse x3))))
                                  (cdr (reverse (cons (car x4) (reverse x4))))
                                  (cdr (reverse (cons (car x5) (reverse x5))))
                                )
                              )
                            )
                          )
                          x6
                  )
                )
        )
        (entupd lw)
      )
    )
  )

  (defun offd ( sign ip tl / dl )
    (setq dl (mapcar '(lambda ( x )
                        (distance ip
                          (inters
                            ip
                            (polar ip (+ (* 0.5 pi) (angle (car x) (cadr x))) 1.0)
                            (car x)
                            (polar (car x) (angle (car x) (cadr x)) 1.0)
                            nil
                          )
                        )
                      ) tl
              )
    )
    (vl-some '(lambda ( x )
               (if
                 (>
                   (-
                     (length dl)
                     (length (vl-remove-if '(lambda ( y ) (equal x y 0.05)) dl))
                   ) 2
                 )
                 x
               )
             ) (vl-sort dl sign)
    )
  )

  (defun inside-p ( p lw lwi )
    (< (distance p (vlax-curve-getclosestpointto lwi p)) (distance p (vlax-curve-getclosestpointto lw p)))
  )

  (defun collinear-p ( p1 p p2 )
    (equal (distance p1 p2) (+ (distance p1 p) (distance p p2)) 1e-6)
  )

  (defun unique ( pl )
    (if pl
      (cons (car pl)
            (unique
              (vl-remove-if
                '(lambda ( x )
                   (equal x (car pl) 1e-6)
                 )
                (cdr pl)
              )
            )
      )
    )
  )

  (defun chkcircinside ( pp tll / d ci ipp ippl tst )
    (if (and pp tll)
      (progn
        (setq ci (entmakex (list (cons 0 "CIRCLE") (cons 10 pp) (cons 40 (offd (function <) pp tll)))))
        (if (setq ipp (vlax-invoke (vlax-ename->vla-object ci) 'intersectwith (vlax-ename->vla-object ent) acextendnone))
          (progn
            (while ipp
              (setq ippl (cons (list (car ipp) (cadr ipp) (caddr ipp)) ippl))
              (setq ipp (cdddr ipp))
            )
            (if (or (not ippl) (vl-every '(lambda ( x ) (inside-p x ent enti)) (apply 'append (mapcar '(lambda ( x ) (list (vlax-curve-getpointatparam ci (- x 0.1)) (vlax-curve-getpointatparam ci (+ x 0.1)))) (mapcar '(lambda ( x ) (vlax-curve-getparamatpoint ci x)) ippl)))))
              (setq tst t)
            )
          )
          (setq tst t)
        )
        (if (and ci (not (vlax-erased-p ci)))
          (entdel ci)
        )
      )
    )
    tst
  )

  (defun preprocess1 ( vl vli / ip ) ;;; iplst - lexical global variable
    (setq iplst (mapcar '(lambda ( p1 p2 p3 p4 / ip )
                          (if
                            (and
                              (setq ip (inters p1 p2 p3 p4 nil))
                              (inside-p ip ent enti)
                              (equal (unit (mapcar '- ip p1)) (unit (mapcar '- p2 p1)) 1e-2)
                              (equal (unit (mapcar '- ip p3)) (unit (mapcar '- p4 p3)) 1e-2)
                              (inside-p (mapcar '+ p1 (mapcar '* (unit (mapcar '- ip p1)) (list 1e-2 1e-2))) ent enti)
                              (inside-p (mapcar '+ p3 (mapcar '* (unit (mapcar '- ip p3)) (list 1e-2 1e-2))) ent enti)
                            )
                            (list ip (list p1 p3))
                            (list nil nil)
                          )
                        )
                        vl
                        vli
                        (append (cdr vl) (list (car vl)))
                        (append (cdr vli) (list (car vli)))
                )
    )
    iplst
  )

  (defun preprocess2 ( vl vli mm / ip ) ;;; iplst - lexical global variable
    (setq iplst (mapcar '(lambda ( p1 p2 p3 p4 / ip )
                          (if
                            (and
                              (setq ip (inters p1 p2 p3 p4 nil))
                              (inside-p ip ent enti)
                              (equal (unit (mapcar '- ip p1)) (unit (mapcar '- p2 p1)) 1e-2)
                              (equal (unit (mapcar '- ip p3)) (unit (mapcar '- p4 p3)) 1e-2)
                              (inside-p (mapcar '+ p1 (mapcar '* (unit (mapcar '- ip p1)) (list 1e-2 1e-2))) ent enti)
                              (inside-p (mapcar '+ p3 (mapcar '* (unit (mapcar '- ip p3)) (list 1e-2 1e-2))) ent enti)
                            )
                            (list ip (list p1 p3))
                            (list nil nil)
                          )
                        )
                        vl
                        vli
                        (mapcar '(lambda ( x ) (car mm)) vl)
                        (mapcar '(lambda ( x ) (cadr mm)) vli)
                )
    )
    iplst
  )

  (defun subbody ( ipd )
    (if (and ipd (chkcircinside (car ipd) tlll))
      (progn
        (setq ppp (cons (car ipd) ppp))
        (if
          (and
            (setq p1
              (vl-some '(lambda ( x )
                (if
                  (equal
                    (unit (mapcar '- (car ipd) x))
                    (unit (mapcar '- (car ipd) (caadr ipd)))
                    1e-6
                  )
                  x
                )
              ) vll
              )
            )
            (setq pp1
              (vl-some '(lambda ( x )
                (if
                  (equal
                    (unit (mapcar '- (car ipd) x))
                    (unit (mapcar '- (car ipd) p1))
                    1e-6
                  )
                  x
                )
              ) vlll
              )
            )
          )
          (if (not (vl-position (list (car ipd) pp1) lil))
            (setq lil (cons (list (car ipd) pp1) lil))
          )
          (if p1
            (if (not (vl-position (list (car ipd) p1) lil))
              (setq lil (cons (list (car ipd) p1) lil))
            )
            (if (not (vl-position (list (car ipd) (caadr ipd)) lil))
              (setq lil (cons (list (car ipd) (caadr ipd)) lil))
            )
          )
        )
        (if
          (and
            (setq p2
              (vl-some '(lambda ( x )
                (if
                  (equal
                    (unit (mapcar '- (car ipd) x))
                    (unit (mapcar '- (car ipd) (cadadr ipd)))
                    1e-6
                  )
                  x
                )
              ) vll
              )
            )
            (setq pp2
              (vl-some '(lambda ( x )
                (if
                  (equal
                    (unit (mapcar '- (car ipd) x))
                    (unit (mapcar '- (car ipd) p2))
                    1e-6
                  )
                  x
                )
              ) vlll
              )
            )
          )
          (if (not (vl-position (list (car ipd) pp2) lil))
            (setq lil (cons (list (car ipd) pp2) lil))
          )
          (if p2
            (if (not (vl-position (list (car ipd) p2) lil))
              (setq lil (cons (list (car ipd) p2) lil))
            )
            (if (not (vl-position (list (car ipd) (cadadr ipd)) lil))
              (setq lil (cons (list (car ipd) (cadadr ipd)) lil))
            )
          )
        )
        (if (and ipd (caddr ipd))
          (progn
            (setq lwnl (vl-catch-all-apply '_offset (list ent (- (caddr ipd)))))
            (if (and lwnl (vl-catch-all-error-p lwnl))
              (progn
                (prompt "\ncatched an error in _offset sub")
                (setq lwnl nil)
              )
              (if (and lwnl (not (vl-catch-all-error-p lwnl)) (> (length lwnl) 1))
                (setq lwnl (vl-sort lwnl '(lambda ( a b ) (< (distance (car ipd) (vlax-curve-getclosestpointto a (car ipd))) (distance (car ipd) (vlax-curve-getclosestpointto b (car ipd)))))))
              )
            )
          )
        )
        lwnl
      )
    )
  )

  (defun subprocess ( iplst flag / p1 p2 pp1 pp2 iplstoffd ipd ) ;;; lst - lexical global variable
    (if (setq iplst (vl-remove-if '(lambda ( x ) (or (null (car x)) (null (cadr x)))) iplst))
      (progn
        (setq iplstoffd (mapcar '(lambda ( x ) (if (and (car x) (cadr x))
                                                 (list
                                                   (mapcar '+ '(0.0 0.0) (car x))
                                                   (mapcar '(lambda ( y ) (mapcar '+ '(0.0 0.0) y)) (cadr x))
                                                   (offd (function <) (mapcar '+ '(0.0 0.0) (car x)) tlll)
                                                 )
                                                 (list nil nil nil)
                                               )
                                 ) iplst
                        )
        )
        (setq iplstoffd (vl-remove-if '(lambda ( x ) (null (caddr x))) iplstoffd))
        (if (not flag)
          (progn
            (setq iplstoffd (vl-sort iplstoffd '(lambda ( a b ) (> (caddr a) (caddr b)))))
            (foreach ipd iplstoffd
              (if (not (vl-position (car iplstoffd) lst))
                (setq ipd (car iplstoffd) lst (cons ipd lst))
                (progn
                  (setq iplstoffd (cdr (member (car lst) iplstoffd)))
                  (setq ipd (car iplstoffd) lst (cons ipd lst))
                )
              )
              (subbody ipd)
            )
          )
          (progn
            (setq iplstoffd (vl-sort iplstoffd '(lambda ( a b )
              (< (distance (car a) (caar lil)) (distance (car b) (caar lil)))
              ))
            )
            (if (not (vl-position (car iplstoffd) lst))
              (setq ipd (car iplstoffd) lst (cons ipd lst))
              (progn
                (setq iplstoffd (cdr (member (car lst) iplstoffd)))
                (setq ipd (car iplstoffd) lst (cons ipd lst))
              )
            )
            (subbody ipd)
          )
        )
      )
    )
  )

  (defun process ( lw / mc lwi lwx vl vli iplst tl lwnl mm loop li out ) ;;; lil, vll, vlli, tll, lwnl, ppp, done, lstt, flag - lexical global variables ;;;

    (defun mc ( p lw / mid acos angle3d ci pl mp p1 p2 p3 p4 par1 par2 par3 par4 )

      (defun mid ( ci p1 p2 / par1 par2 mp )
        (setq par1 (vlax-curve-getparamatpoint ci p1) par2 (vlax-curve-getparamatpoint ci p2))
        (setq mp (vlax-curve-getpointatparam ci (/ (+ par1 par2) 2.0)))
      )

      (defun acos ( x )
        (cond
          ( (equal x 1.0 1e-8) 0.0 )
          ( (equal x -1.0 1e-8) pi )
          ( (and (>= x 0.0) (equal x 0.0 1e-8))
            (/ pi 2.0)
          )
          ( (and (<= x 0.0) (equal x -0.0 1e-8))
            (* 3.0 (/ pi 2.0))
          )
          ( t
            (atan (sqrt (- 1.0 (* x x))) x)
          )
        )
      )

      (defun angle3d ( p1 por p2 / vec1 vec2 dd ang )
        (setq vec1 (unit (mapcar (function -) p1 por)))
        (setq vec2 (unit (mapcar (function -) p2 por)))
        (setq dd (distance vec1 vec2))
        (setq ang (acos (- 1.0 (/ (expt dd 2) 2.0))))
        (if (minusp ang) (+ ang pi) ang)
      )

      (setq ci (entmakex (list (cons 0 "CIRCLE") (cons 10 p) (cons 40 1.0)))) ;;; adjust radius of circle to be adequate to DWG...
      (setq pl (vlax-invoke (vlax-ename->vla-object ci) 'intersectwith (vlax-ename->vla-object lw) acextendnone))
      (cond
        ( (= (length pl) 12)
          (setq p1 (list (car pl) (cadr pl)))
          (setq p2 (list (nth 3 pl) (nth 4 pl)))
          (setq p3 (list (nth 6 pl) (nth 7 pl)))
          (setq p4 (list (nth 9 pl) (nth 10 pl)))
          (cond
            ( (vl-some '(lambda ( li ) (or (equal (unit (mapcar '- (car li) (cadr li))) (unit (mapcar '- (mid ci p1 p2) p)) 1e-3) (equal (unit (mapcar '- (car li) (cadr li))) (unit (mapcar '- p (mid ci p1 p2))) 1e-3))) lil)
              (if (< (angle3d p3 p p4) (* 0.5 pi))
                (setq mp (mid ci p3 p4))
                (setq mp (polar p (angle p3 p4) 1.0))
              )
            )
            ( (vl-some '(lambda ( li ) (or (equal (unit (mapcar '- (car li) (cadr li))) (unit (mapcar '- (mid ci p2 p3) p)) 1e-3) (equal (unit (mapcar '- (car li) (cadr li))) (unit (mapcar '- p (mid ci p2 p3))) 1e-3))) lil)
              (if (< (angle3d p4 p p1) (* 0.5 pi))
                (setq mp (mid ci p4 p1))
                (setq mp (polar p (angle p4 p1) 1.0))
              )
            )
            ( (vl-some '(lambda ( li ) (or (equal (unit (mapcar '- (car li) (cadr li))) (unit (mapcar '- (mid ci p3 p4) p)) 1e-3) (equal (unit (mapcar '- (car li) (cadr li))) (unit (mapcar '- p (mid ci p3 p4))) 1e-3))) lil)
              (if (< (angle3d p1 p p2) (* 0.5 pi))
                (setq mp (mid ci p1 p2))
                (setq mp (polar p (angle p1 p2) 1.0))
              )
            )
            ( (vl-some '(lambda ( li ) (or (equal (unit (mapcar '- (car li) (cadr li))) (unit (mapcar '- (mid ci p4 p1) p)) 1e-3) (equal (unit (mapcar '- (car li) (cadr li))) (unit (mapcar '- p (mid ci p4 p1))) 1e-3))) lil)
              (if (< (angle3d p2 p p3) (* 0.5 pi))
                (setq mp (mid ci p2 p3))
                (setq mp (polar p (angle p2 p3) 1.0))
              )
            )
          )
        )
        ( (= (length pl) 6)
          (setq p1 (list (car pl) (cadr pl)))
          (setq p2 (list (nth 3 pl) (nth 4 pl)))
          (setq mp (mid ci p1 p2))
        )
      )
      (if (and ci (not (vlax-erased-p ci)))
        (entdel ci)
      )
      (list p mp)
    )

    (if lw
      (progn
        (setq vl (mapcar 'cdr (vl-remove-if '(lambda ( x ) (/= (car x) 10)) (setq lwx (entget lw)))))
        (if (not vll)
          (setq vll vl)
        )
        (setq lwi (vlax-vla-object->ename (car (vlax-invoke (vlax-ename->vla-object lw) 'offset -1e-3))))
        (setq vli (mapcar 'cdr (vl-remove-if '(lambda ( x ) (/= (car x) 10)) (entget lwi))))
        (if (not vlli)
          (setq vlli vli)
        )
        (setq tl (mapcar '(lambda ( a b ) (list a b)) vl (append (cdr vl) (list (car vl)))))
        (if (not tll)
          (setq tll tl)
        )
        (setq iplst nil)
        (setq iplst (preprocess1 vll vlli))
        (subprocess iplst nil)
        (foreach li (reverse lil)
          (setq loop t)
          (while loop
            (if (not (vl-position (setq mm (mc (car li) (ssname (ssget "_CP" (list (mapcar '+ (list -5e-3 -5e-3) (car li)) (mapcar '+ (list 5e-3 5e-3) (car li))) '((0 . "LWPOLYLINE"))) 0))) lstt))
              (progn
                (setq lstt (cons mm lstt))
                (setq iplst nil out nil)
                (setq iplst (preprocess2 vll vlli mm))
                (setq out (vl-catch-all-apply 'subprocess (list iplst t)))
                (if (vl-catch-all-error-p out)
                  (progn
                    (prompt "\ncatched error in preprocess2 -> subprocess ...")
                    (setq loop nil)
                  )
                )
                (setq li (car lil))
              )
              (setq loop nil)
            )
          )
        )
        (if (and lwi (not (vlax-erased-p lwi)))
          (entdel lwi)
        )
        lwnl
      )
    )
  )

  (or cad (progn (vl-load-com) (setq cad (vlax-get-acad-object))))
  (or doc (setq doc (vla-get-activedocument cad)))
  (or spc (setq spc (vla-get-block (setq lay (vla-get-activelayout doc)))))

  (if (= 8 (logand 8 (getvar 'undoctl)))
    (vla-endundomark doc)
  )
  (vla-startundomark doc)
  (if
    (and
      (setq lw (car (entsel "\nPick boundary closed polygonal LWPOLYLINE with only straight segments...")))
      (= (cdr (assoc 0 (setq lwx (entget lw)))) "LWPOLYLINE")
      (= 1 (logand 1 (cdr (assoc 70 lwx))))
      (vl-every '(lambda ( x ) (= 0.0 (cdr x))) (vl-remove-if '(lambda ( x ) (/= (car x) 42)) lwx))
      (setq el (entlast) ent lw)
    )
    (progn
      (setq lwi (vlax-vla-object->ename (car (vlax-invoke (vlax-ename->vla-object lw) 'offset -1e-3))))
      (if (> (vlax-curve-getarea lwi) (vlax-curve-getarea lw))
        (setq lw (rlw lw)) ;;; force main lwpolyline CCW - counter clockwise ;;;
      )
      (setq enti (vlax-vla-object->ename (car (vlax-invoke (vlax-ename->vla-object ent) 'offset -1e-3))))
      (if (and lwi (not (vlax-erased-p lwi)))
        (entdel lwi)
      )
      (if (not f)
        (progn
          (setq vlll (mapcar 'cdr (vl-remove-if '(lambda ( x ) (/= (car x) 10)) (entget ent))))
          (setq vllli (mapcar 'cdr (vl-remove-if '(lambda ( x ) (/= (car x) 10)) (entget enti))))
          (setq tlll (mapcar '(lambda ( a b ) (list a b)) vlll (append (cdr vlll) (list (car vlll)))))
          (setq f t)
        )
      )
      (while (not done)
        (if
          (and
            (not (vl-catch-all-error-p (setq lwnl (vl-catch-all-apply 'process (list lw)))))
            lwnl
          )
          (while (and (not done) (setq lww (car (vl-sort lwnl '(lambda ( a b ) (> (vlax-curve-getarea a) (vlax-curve-getarea b)))))))
            (setq lwnl (vl-remove lww lwnl))
            (setq lwnl (vl-catch-all-apply 'process (list lww)))
            (if (and lwnl (vl-catch-all-error-p lwnl))
              (setq done t)
            )
          )
          (setq done t)
        )
      ) ;;; main engine ;;;
    )
  )
  (*error* nil)
)